class DoppelPendel {

  float m1, m2; //die Massen an der Unterseite der beiden Pendel
  float g;      //Erdbeschleunigung
  float l1, l2; //länge der beiden Arme
  float alpha1, alpha2; //aktuelle Winkel
  float alpha1Neu, alpha2Neu; //geänderte Winkel
  float speicher0,speicher1,speicher2,speicher3;//Zwischenspeicher zur Berechnung der neuen Position
 

  DoppelPendel(float m1, float m2, float l1, float l2, float alpha1, float alpha2){
    this.m1 = m1;
    this.m2 = m2;
    this.l1 = l1;
    this.l2 = l2;
    this.alpha1 = alpha1;
    this.alpha2 = alpha2;
    alpha1Neu = 0;
    alpha2Neu = 0;
    g = 10;   
  }
  
  void update(float h) {
    
    //numerische Lösung mit Runge-Kutta
    speicher0 = alpha1Neu; 
    speicher1 = -g*(2*m1 + m2)*sin(alpha1) - 
            m2*g*sin(alpha1-2*alpha2) - 
            2*sin(alpha1 - alpha2)*m2*(alpha2Neu*alpha2Neu * l2 + 
            alpha1Neu*alpha1Neu*l1 * cos(alpha1 - alpha2));
    speicher1 = speicher1/(l1*(2*m1 + m2 -m2*cos(2*alpha1-2*alpha2)));
    speicher1 = speicher1-0.08*alpha1Neu/(abs(alpha1Neu)+0.005); //Versuch, die Reibung zu berücksichtigen
    speicher2 = alpha2Neu;    
    speicher3 = 2*sin(alpha1 - alpha2)*(alpha1Neu*alpha1Neu*l1*(m1 + m2) + 
            g*(m1 + m2)*cos(alpha1) +
            alpha2Neu*alpha2Neu*l2*m2*cos(alpha1 - alpha2)); 
    speicher3 = speicher3/(l2*(2*m1 + m2 -m2*cos(2*alpha1-2*alpha2)));
    speicher3 = speicher3-0.1*alpha2Neu/(abs(alpha2Neu)+0.005); //Reibung s.o.
    alpha1 += h*speicher0; 
    alpha1Neu += h*speicher1;   
    alpha2 += h*speicher2; 
    alpha2Neu += h*speicher3;   
  }
  
  void display() { //Zeichnen des Doppelpendels
    stroke(0); strokeWeight(18); fill(255);
    float xEnd = xMitte + s*l1*sin(alpha1);
    float yEnd = yMitte + s*l1*cos(alpha1);
    line(xMitte,yMitte,xEnd,yEnd); 
    strokeWeight(18); //stroke(100);
    line(xEnd,yEnd, xEnd+s*l2*sin(alpha2),yEnd+s*l2*cos(alpha2));
    stroke(0);strokeWeight(2);//fill(0,150,0);
    ellipse(xEnd,yEnd,45,45);
    stroke(0);strokeWeight(2);//fill(0,0,150);
    ellipse(xEnd+s*l2*sin(alpha2),yEnd+s*l2*cos(alpha2),30,30);
    stroke(0);strokeWeight(2);fill(255);
    ellipse(width/2,height/2,12,12); 
     
  }
}