/////////////////////////////////////////////////////////////////////////////////
//Beispiel Doppelpendel (bzw. Chaospendel) im Kapitel Simulation
//setup und draw für das Doppelpendel. 
///////////////////////////////////////////////////////////////////////////////////
float xAlt, yAlt, xNeu, yNeu; //Koordinaten der beiden Massen
float xMitte, yMitte;    //Aufhängungsort des Pendels
float s = 35.;    //Faktor für das Zeichnen der Arme                  
float m1 = random(2,4);float m2= random(1,3);//in den vorgegebenen Grenzen zufällige Massen
float l1= random(5,8); float l2= random(3,5);//in den vorgegebenen Grenzen zufällige Pendellängen
float alpha1 = 3.14; float alpha2 = random(3.2,3.6);//

DoppelPendel pendel = new DoppelPendel(m1,m2,l1,l2,alpha1,alpha2);
ArrayList<PVector> punkte = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte

void setup() {
  size(900,900);
  xMitte = width/2.;
  yMitte = height/2.;
  xAlt = xMitte + s*pendel.l1*sin(pendel.alpha1) + s*pendel.l2*sin(pendel.alpha2); 
  yAlt = yMitte + s*pendel.l1*cos(pendel.alpha1) + s*pendel.l2*cos(pendel.alpha2);  
  punkte.add(new PVector(xAlt,yAlt));
  frameRate(980);//Wählen Sie frameRate(480) wenn der Weg nicht gezeichnet wird.
}

void draw() {
  background(255);  
  pendel.update(0.01);//die update-Methode der DoppelPendelklasse wird aufgerufen
  xNeu = xMitte + s*pendel.l1*sin(pendel.alpha1) + s*pendel.l2*sin(pendel.alpha2);
  yNeu = yMitte + s*pendel.l1*cos(pendel.alpha1) + s*pendel.l2*cos(pendel.alpha2);  
  punkte.add(new PVector(xNeu,yNeu));
  strokeWeight(5);
  for(int i =0; i< punkte.size()-1 ;i++){
     if( i%512<256){ stroke(255-i%256,0,i%256);}  
     else{ stroke(i%256,0,255-i%256);}
     //line(...) auskommentieren wenn der Weg nicht gezeichnet werden soll. frameRate auf 460 einstellen
     line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+1).x,punkte.get(i+1).y);
  }
  xAlt = xNeu;
  yAlt = yNeu;  
  stroke(0);
  pendel.display();//die display-Methode der DoppelPendelklasse wird aufgerufen
  if (mousePressed){noLoop(); }//anhalten des Pendels
}

void keyPressed() { save("test.png"); }